type t = {
	b: string Rtree.t;
	nxt: Var.t;
}

type basis_t = t

let nil = { b = Rtree.Nil; nxt = Var.XH }

let add (b: basis_t) (id: string): Var.t * basis_t =
	(b.nxt, {
		b = Rtree.set "" b.b b.nxt id;
		nxt = Var.next b.nxt
	})

let mk l =
	let (vars, b) = List.fold_left
		(fun (vars, b) s -> let (v, b1) = add b s in (v::vars, b1))
			([], nil) l
	in
	(List.rev vars, b)

let pr (b: basis_t) (v: Var.t): string =
	let id = Rtree.get "" b.b v in
	if id = "" then
		invalid_arg "Basis.pr"
	else
		id
