(** This module provides the necessary glue between the certified certificate checker,
which operates on data types extracted from Coq developements, and libpoly. *)

val zToPos: Num.Z.t -> BinPos.positive
val zToZ: Num.Z.t -> BinInt.coq_Z
val nToNum: Num.t -> NumC.t
val vToVec: Vec.t -> VecC.t
val cToCons: Cstr.t -> ConsC.t
val pToPol: (int * Cstr.t) list -> PolC.t

val check: (int * Cstr.t) list -> (int * Cstr.t) list -> Cert.t -> bool
val checkMeet: (int * Cstr.t) list -> (int * Cstr.t) -> (int * Cstr.t) list option -> Cert.t -> bool
