type t = XH | XO of t | XI of t

type var_t = t

let next (bp: var_t): var_t =
	let rec next_rec (bp': var_t): var_t * bool =
		match bp' with
		  XH -> (XH, true)
		| XI tail -> (
			match next_rec tail with
			  (tail', true) -> (XO tail', true)
			| (tail', false) -> (XI tail', false))
		| XO tail -> (
			match next_rec tail with
			  (tail', true) -> (XI tail', false)
			| (tail', false) -> (XO tail', false))
	in
	let (res, overflow) = next_rec bp in
	if overflow then XO res else res
